-- EquipInfosWindow.lua
-- Written by Habna


SlotsBG = {"0x41007eed", "0x41007ef6", "0x41007ef7", "0x41007eef", "0x41007eee", "0x41007ee9", "0x41007ef0", "0x41007ef9", "0x41007ef8",
		"0x41007ef4", "0x41007ef3", "0x41007ef2", "0x41007ef1", "0x41007ef5", "0x41007efa", "0x41007eea", "0x41007eeb", "0x41007eec",
		"0x41007efb", "0x410e8680"};

SlotsText = {L["EWST1"], L["EWST2"], L["EWST3"], L["EWST4"], L["EWST5"], L["EWST6"], L["EWST7"], L["EWST8"], L["EWST9"],
		L["EWST10"], L["EWST11"], L["EWST12"], L["EWST13"], L["EWST14"], L["EWST15"], L["EWST16"], L["EWST17"],	L["EWST18"],
		L["EWST19"], L["EWST20"]};


function frmDurabilityInfosWindow()
	wDurabilityInfos = Turbine.UI.Lotro.Window();
	--wDurabilityInfos = Turbine.UI.Lotro.GoldWindow();
	frmDI = true;
	wDurabilityInfos:SetSize( 390, 440 );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = wDurabilityInfos:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight / 2 );
    wDurabilityInfos:SetPosition( left, top );
	wDurabilityInfos:SetText( L["DWTitle"] );
	wDurabilityInfos:SetVisible( true );
	wDurabilityInfos:SetWantsKeyEvents( true );
	--wDurabilityInfos:SetZOrder( 2 );
	wDurabilityInfos:Activate();

	wDurabilityInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wDurabilityInfos:Close();
		elseif ( args.Action == 268435635 ) then -- **v Hide wBackground if F12 key is press v**
			wDurabilityInfos:SetVisible( not wDurabilityInfos:IsVisible() );
		end
	end

	wDurabilityInfos.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then RefreshListBox(); end
	end

	wDurabilityInfos.Closing = function( sender, args )
		frmDI = nil;
		wDurabilityInfos = nil;
	end

	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( wDurabilityInfos );
	lblBackPack:SetText( L["DWLbl"] );
	lblBackPack:SetPosition( 15, 30);
	lblBackPack:SetSize( 350 , 35 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblBackPack:SetForeColor( green );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( wDurabilityInfos );
	ListBoxBorder:SetPosition( lblBackPack:GetLeft() - 2, lblBackPack:GetHeight() + 25 );
	ListBoxBorder:SetSize( 354, 354 );
	ListBoxBorder:SetBackColor( grey );
	ListBoxBorder:SetVisible( true );

	ListBox = Turbine.UI.ListBox();
	ListBox:SetParent( wDurabilityInfos );
	ListBox:SetPosition( ListBoxBorder:GetLeft() + 2, ListBoxBorder:GetTop() + 2 );
	ListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	ListBox:SetMaxItemsPerLine( 3 );
	ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	ListBox:SetBackColor( black );

	ScrollBar = Turbine.UI.Lotro.ScrollBar();
	ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	ScrollBar:SetParent( wDurabilityInfos );
	ScrollBar:SetPosition( ListBoxBorder:GetWidth() + 15, ListBoxBorder:GetTop() );
	ScrollBar:SetHeight( ListBoxBorder:GetHeight() );
	ScrollBar:SetWidth( 10 );
	ListBox:SetVerticalScrollBar( ScrollBar );
	
	RefreshListBox();
end

function RefreshListBox()
	local PlayerEquipment = Player:GetEquipment();
	
	local itemCtl = {};
	local itemEquip = {};
	local itemLbl = {};
	local itemLblScore = {};
	
	local itemsTotDurability, itemDurability, numItems = 0, 0, 0;
	ListBox:ClearItems();
	
	for i = 1, 20 do
		PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = SlotsText[i] .. ":\n" .. PlayerEquipItem:GetName();
			itemEquip[i].WearState = PlayerEquipItem:GetWearState();

			--Some item like pocket item dont have durability, so it's indestructible so always 100% durability
			if itemEquip[i].WearState == 0 then itemEquip[i].WearState = 100; end

			itemEquip[i].item = true;
			itemEquip[i]:SetPosition( 3, 3 );
		else
			itemEquip[i].Name = SlotsText[i] .. ":\n" .. L["EWItemNP"];
			itemEquip[i].item = false;
			itemEquip[i].WearState = 0;
		end

		-- Item control background
		itemCtl[i] = Turbine.UI.Control();
		itemCtl[i]:SetSize( 44, 44 );
		itemCtl[i]:SetBackground( tonumber(SlotsBG[i]) );
		itemCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		itemEquip[i]:SetParent( itemCtl[i] );
					
		-- Item name
		itemLbl[i] = Turbine.UI.Label();
		itemLbl[i]:SetSize( ListBox:GetWidth() - itemCtl[i]:GetWidth() - 30, itemCtl[i]:GetHeight() );
		itemLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		itemLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		--itemLbl[i]:SetForeColor( white );
		
		if itemEquip[i].item == false then itemLbl[i]:SetForeColor( red ); end
		
		itemLbl[i]:SetText( itemEquip[i].Name );

		-- Item Durability
		if itemEquip[i].WearState == 2 then itemDurability = 100; end -- Pristine / parfait
		if itemEquip[i].WearState == 4 then itemDurability = 75; end -- Worn / us
		if itemEquip[i].WearState == 1 then itemDurability = 50; end -- Damaged / endommag
		if itemEquip[i].WearState == 3 then itemDurability = 0; end -- Broken / cass
		if itemEquip[i].WearState == 0 then itemDurability = 0; end -- undefined

		itemLblScore[i] = Turbine.UI.Label();
		itemLblScore[i]:SetText( itemDurability .. "%" );
		itemLblScore[i]:SetSize( 30, itemCtl[i]:GetHeight() );
		itemLblScore[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		itemLblScore[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		
		-- Show item
		ListBox:AddItem( itemCtl[i] );
		ListBox:AddItem( itemLbl[i] );
		ListBox:AddItem( itemLblScore[i] );
	end
end