-- EquipInfosWindow.lua
-- Written by Habna


SlotsBG = {"0x41007eed", "0x41007ef6", "0x41007ef7", "0x41007eef", "0x41007eee", "0x41007ee9", "0x41007ef0", "0x41007ef9", "0x41007ef8",
		"0x41007ef4", "0x41007ef3", "0x41007ef2", "0x41007ef1", "0x41007ef5", "0x41007efa", "0x41007eea", "0x41007eeb", "0x41007eec",
		"0x41007efb", "0x410e8680"};

SlotsText = {L["EWST1"], L["EWST2"], L["EWST3"], L["EWST4"], L["EWST5"], L["EWST6"], L["EWST7"], L["EWST8"], L["EWST9"],
		L["EWST10"], L["EWST11"], L["EWST12"], L["EWST13"], L["EWST14"], L["EWST15"], L["EWST16"], L["EWST17"],	L["EWST18"],
		L["EWST19"], L["EWST20"]};

Quality = {L["EWQM1"], L["EWQM2"], L["EWQM3"], L["EWQM4"], L["EWQM5"], L["EWQM6"]};
Durability = {L["EWDM1"], L["EWDM2"], L["EWDM3"], L["EWDM4"], L["EWDM5"], L["EWDM6"], L["EWDM7"], L["EWDM8"]};


function frmEquipInfosWindow()
	wEquipInfos = Turbine.UI.Lotro.Window();
	--wEquipInfos = Turbine.UI.Lotro.GoldWindow();
	frmEI = true;
	wEquipInfos:SetSize( 390, 490 );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = wEquipInfos:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight / 2 );
    wEquipInfos:SetPosition( left, top );
	wEquipInfos:SetText( L["EWTitle"] );
	wEquipInfos:SetVisible( true );
	wEquipInfos:SetWantsKeyEvents( true );
	--wEquipInfos:SetZOrder( 2 );
	wEquipInfos:Activate();

	wEquipInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wEquipInfos:Close();
		elseif ( args.Action == 268435635 ) then -- **v Hide wBackground if F12 key is press v**
			wEquipInfos:SetVisible( not wEquipInfos:IsVisible() );
		end
	end

	wEquipInfos.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then RefreshListBox(); end
	end

	wEquipInfos.Closing = function( sender, args )
		frmEI = nil;
		wEquipInfos = nil;
	end

	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( wEquipInfos );
	lblBackPack:SetText( L["EWLbl"] );
	lblBackPack:SetPosition( 15, 30);
	lblBackPack:SetSize( 350 , 35 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblBackPack:SetForeColor( green );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( wEquipInfos );
	ListBoxBorder:SetPosition( lblBackPack:GetLeft() - 2, lblBackPack:GetHeight() + 25 );
	ListBoxBorder:SetSize( 354, 354 );
	ListBoxBorder:SetBackColor( grey );
	ListBoxBorder:SetVisible( true );

	ListBox = Turbine.UI.ListBox();
	ListBox:SetParent( wEquipInfos );
	ListBox:SetPosition( ListBoxBorder:GetLeft() + 2, ListBoxBorder:GetTop() + 2 );
	ListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	ListBox:SetMaxItemsPerLine( 3 );
	ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	ListBox:SetBackColor( black );

	ScrollBar = Turbine.UI.Lotro.ScrollBar();
	ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	ScrollBar:SetParent( wEquipInfos );
	ScrollBar:SetPosition( ListBoxBorder:GetWidth() + 15, ListBoxBorder:GetTop() );
	ScrollBar:SetHeight( ListBoxBorder:GetHeight() );
	ScrollBar:SetWidth( 10 );
	ListBox:SetVerticalScrollBar( ScrollBar );
	
	QualityLbl = Turbine.UI.Label();
	QualityLbl:SetParent( wEquipInfos );
	QualityLbl:SetText( L["EWQuality"] );
	QualityLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	QualityLbl:SetPosition( ListBoxBorder:GetLeft(), ListBoxBorder:GetTop() + ListBoxBorder:GetHeight() + 5 );
	QualityLbl:SetSize( string.len(QualityLbl:GetText()) * 7.5 , 15 );
	QualityLbl:SetForeColor( green );
	
	import (AppClassD.."DropDown");
	MyDropDown = DropDown.Create( Quality, L["EWQM1"]);
	MyDropDown:SetParent( wEquipInfos );
	--MyDropDown:ApplyWidth ( 115 );
	MyDropDown:SetMaxItems( 5 );
	MyDropDown:SetPosition( QualityLbl:GetLeft(), QualityLbl:GetTop() + QualityLbl:GetHeight() + 5 );
	MyDropDown:SetVisible( true );

	MyDropDown.ItemChanged = function () -- The event that's executed when a menu item is clicked.
		selectedItem = MyDropDown:GetText();
		if selectedItem == L["EWQM1"] then Filter = nil; end
		if selectedItem == L["EWQM2"] then Filter = 5; end
		if selectedItem == L["EWQM3"] then Filter = 4; end
		if selectedItem == L["EWQM4"] then Filter = 3; end
		if selectedItem == L["EWQM5"] then Filter = 2; end
		if selectedItem == L["EWQM6"] then Filter = 1; end
		RefreshListBox();
	end

	MyDropDown2 = DropDown.Create( Durability, L["EWDM1"]);
	MyDropDown2:SetParent( wEquipInfos );
	--MyDropDown2:ApplyWidth ( 115 );
	MyDropDown2:SetMaxItems( 5 );
	MyDropDown2:SetPosition( ListBoxBorder:GetLeft() + ListBoxBorder:GetWidth() - MyDropDown2:GetWidth(), MyDropDown:GetTop() );
	MyDropDown2:SetVisible( true );

	MyDropDown2.ItemChanged = function () -- The event that's executed when a menu item is clicked.
		selectedItem = MyDropDown2:GetText();
		if selectedItem == L["EWDM1"] then Filter2 = nil; end
		if selectedItem == L["EWDM2"] then Filter2 = 7; end
		if selectedItem == L["EWDM3"] then Filter2 = 1; end
		if selectedItem == L["EWDM4"] then Filter2 = 2; end
		if selectedItem == L["EWDM5"] then Filter2 = 3; end
		if selectedItem == L["EWDM6"] then Filter2 = 4; end
		if selectedItem == L["EWDM7"] then Filter2 = 5; end
		if selectedItem == L["EWDM8"] then Filter2 = 6; end
		RefreshListBox();
	end

	DurabilityLbl = Turbine.UI.Label();
	DurabilityLbl:SetParent( wEquipInfos );
	DurabilityLbl:SetText( L["EWDurability"] );
	DurabilityLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	DurabilityLbl:SetPosition( MyDropDown2:GetLeft(), QualityLbl:GetTop() );
	DurabilityLbl:SetSize( string.len(DurabilityLbl:GetText()) * 7.5 , 15 );
	DurabilityLbl:SetForeColor( green );

	FoundItemsLbl = Turbine.UI.Label();
	FoundItemsLbl:SetParent( wEquipInfos );
	FoundItemsLbl:SetPosition( ListBoxBorder:GetLeft(), wEquipInfos:GetHeight() - 25 );
	FoundItemsLbl:SetSize( wEquipInfos:GetWidth() , 15 );
	FoundItemsLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	FoundItemsLbl:SetForeColor( red );

	Filter, Filter2 = nil, nil;
	RefreshListBox();
end

function RefreshListBox()
	local PlayerEquipment = Player:GetEquipment();
	
	local itemCtl = {};
	local itemEquip = {};
	local itemLbl = {};
	local itemLblScore = {};
	local itemTotScore, itemScore, itemFound = 0, 0, 0;
	ListBox:ClearItems();
	
	for i = 1, 20 do
		PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = SlotsText[i] .. ":\n" .. PlayerEquipItem:GetName();
			itemEquip[i].item = true;
			itemEquip[i].Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Durability = PlayerEquipItem:GetDurability();
			itemEquip[i]:SetPosition( 3, 3 );
		else
			itemEquip[i].Name = SlotsText[i] .. ":\n" .. L["EWItemNP"];
			itemEquip[i].item = false;
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
		end

		-- Item control background
		itemCtl[i] = Turbine.UI.Control();
		itemCtl[i]:SetSize( 44, 44 );
		itemCtl[i]:SetBackground( tonumber(SlotsBG[i]) );
		itemCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		itemEquip[i]:SetParent( itemCtl[i] );
					
		-- Item name
		itemLbl[i] = Turbine.UI.Label();
		itemLbl[i]:SetSize( ListBox:GetWidth() - itemCtl[i]:GetWidth() - 30, itemCtl[i]:GetHeight() );
		itemLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		itemLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		--itemLbl[i]:SetForeColor( white );
		
		if itemEquip[i].item == false then itemLbl[i]:SetForeColor( red ); end
		
		itemLbl[i]:SetText( itemEquip[i].Name );

		-- Quality 5 -> white items - Common
		-- Quality 4 -> yellow items - Uncommon
		-- Quality 3 -> cyan items - Incomparable
		-- Quality 2 -> purple items - Rare
		-- Quality 1 -> orange items - Legendary
		-- Quality 0 -> ?? items - Undefined
		--write("Head item quality: " .. tostring(PlayerEquipItem:GetQuality()));

		-- Durability ( 0: Undefined / 1: Substantial / 2: Brittle / 3: Normal / 4: Tough / 5: Filmsy / 6: Indestructible / 7: Weak )
		--write("Head item durability: " .. tostring(PlayerEquipItem:GetDurability()));

		-- Item Score
		if itemEquip[i].Quality == 5 then itemScore = 50; end
		if itemEquip[i].Quality == 4 then itemScore = 100; end
		if itemEquip[i].Quality == 3 then itemScore = 150; end
		if itemEquip[i].Quality == 2 then itemScore = 200; end
		if itemEquip[i].Quality == 1 then itemScore = 250; end
		if itemEquip[i].Quality == 0 then itemScore = 0; end
		
		if itemEquip[i].Durability == 0 then itemScore = itemScore + 0; end
		if itemEquip[i].Durability == 7 then itemScore = itemScore + 5; end
		if itemEquip[i].Durability == 1 then itemScore = itemScore + 10; end
		if itemEquip[i].Durability == 2 then itemScore = itemScore + 20; end
		if itemEquip[i].Durability == 3 then itemScore = itemScore + 30; end
		if itemEquip[i].Durability == 4 then itemScore = itemScore + 40; end
		if itemEquip[i].Durability == 5 then itemScore = itemScore + 50; end
		if itemEquip[i].Durability == 6 then itemScore = itemScore + 60; end
		
		itemTotScore = itemTotScore + itemScore;

		itemLblScore[i] = Turbine.UI.Label();
		itemLblScore[i]:SetText( itemScore );
		itemLblScore[i]:SetSize( 30, itemCtl[i]:GetHeight() );
		itemLblScore[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		itemLblScore[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		
		-- Show item
		if Filter == nil then
			if Filter2 == nil then
				ListBox:AddItem( itemCtl[i] );
				ListBox:AddItem( itemLbl[i] );
				ListBox:AddItem( itemLblScore[i] );
				if itemEquip[i].item == true then itemFound = itemFound + 1; end
			else
				if itemEquip[i].Durability == Filter2 then
					ListBox:AddItem( itemCtl[i] );
					ListBox:AddItem( itemLbl[i] );
					ListBox:AddItem( itemLblScore[i] );
					itemFound = itemFound + 1;
				end
			end
		else
			if Filter2 == nil then
				if itemEquip[i].Quality == Filter then
					ListBox:AddItem( itemCtl[i] );
					ListBox:AddItem( itemLbl[i] );
					ListBox:AddItem( itemLblScore[i] );
					itemFound = itemFound + 1;
				end
			else
				if itemEquip[i].Quality == Filter and itemEquip[i].Durability == Filter2 then
					ListBox:AddItem( itemCtl[i] );
					ListBox:AddItem( itemLbl[i] );
					ListBox:AddItem( itemLblScore[i] );
					itemFound = itemFound + 1;
				end
			end
		end

		if itemFound <= 1 then FoundItemsLbl:SetText( itemFound .. L["EWItemF"] ); end
		if itemFound >= 2 then FoundItemsLbl:SetText( itemFound .. L["EWItemsF"] ); end
	end
end