-- frmMain.lua
-- written by Habna


resources = {
	--TitanBar = { Background = AppRes.."background.tga" },

	LeftBubble_TopLeftCorner = { Background = AppRes.."lbubble_top_left_corner.tga" },
	LeftBubble_TopRightCorner = { Background = AppRes.."lbubble_top_right_corner.tga" },
	Bubble_MidLeft = { Background = AppRes.."bubble_mid_left.tga" },
	Bubble_BotLeftCorner = { Background = AppRes.."bubble_bot_left_corner.tga" },
	Bubble_Top = { Background = AppRes.."bubble_top.tga" },
	Bubble_Bot = { Background = AppRes.."bubble_bot.tga" },
	Bubble_Mid = { Background = AppRes.."bubble_mid.tga" },
	Bubble_MidRight = { Background = AppRes.."bubble_mid_right.tga" },
	Bubble_BotRightCorner = { Background = AppRes.."bubble_bot_right_corner.tga" },

	RightBubble_TopLeftCorner = { Background = AppRes.."rbubble_top_left_corner.tga" },
	RightBubble_TopRightCorner = { Background = AppRes.."rbubble_top_right_corner.tga" },

	Ring = { Background = AppRes.."ring.tga" },
	Picker = { Background = AppRes.."picker.jpg" },

	RuneKeeper = { Background = AppRes.."runekeeper.tga" }, -- Removed when found in-game icon
	Warden = { Background = AppRes.."warden.tga" } -- Removed when found in-game icon
};

function frmMain()
	--**v Check if TitanBar Reloader is loaded v**
	Turbine.PluginManager.RefreshAvailablePlugins();
	loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();

	TBRChecker = Turbine.UI.Control();
	TBRChecker:SetWantsUpdates( true );
	
	TBRChecker.Update = function( sender, args )
		for k,v in pairs(loaded_plugins) do
			if v.Name == "TitanBar Reloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarReloader' );
				--break;
			end
			if v.Name == "TitanBar Unloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarUnloader' );
				--break;
			end
		end
		TBRChecker:SetWantsUpdates( false );
	end
	--**^

	ToolTipWin = nil;

	wTitanBar = Turbine.UI.Window();
	wTitanBar:SetPosition( 0, 0 );
	wTitanBar:SetSize( screenWidth, 30 );
	--wTitanBar:SetBackground( resources.TitanBar.Background );
	wTitanBar:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	--wTitanBar:SetMouseVisible( false ); -- If set to false, menu will not work.
	wTitanBar:SetWantsKeyEvents( true );
	--wTitanBar:SetZOrder( 10 );
	wTitanBar:SetVisible( true );

	--**v Get player backpack, Class, Race & attributes v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		Player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		Player = Turbine.Gameplay.LocalPlayer;
	end
	
	--Client will crash if :GetAttributes is called and then the plugin is unloaded
	--PlayerAtt = Player:GetAttributes();
	--**^
	
	-- 0x41007f7a (Mail in game icon)

	-- 0x41007eca (Poor server connection)
	-- 0x41007ecb (Broken server connection)
	-- 0x41007ecc (Good server connection)

	
	--**v TitanBar event handlers v**
	wTitanBar.KeyDown = function( sender, args )
		if ( args.Action == 268435635 ) then -- **v Hide TitanBar if F12 key is press v**
			wTitanBar:SetVisible( not wTitanBar:IsVisible() );
		end
	end

	wTitanBar.MouseLeave = function( sender, args )
		if ToolTipWin ~= nil then
			ToolTipWin:SetVisible( false );
			ToolTipWin = nil;
		end
	end

	wTitanBar.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			mouseXPos, mouseYPos = Turbine.UI.Display.GetMousePosition();
			_G.sFromCtr = "TitanBar";
			TitanBarMenu:ShowMenu();
		elseif ( args.Button == Turbine.UI.MouseButton.Left ) then
			
		end
	end

	wTitanBar.Unload = function( sender, args )
		
	end
	--**^ Window event handlers ^**
	
	import (AppCtrD.."MoneyInfos");
	if ShowMoney then
		--import (AppCtrD.."MoneyInfos");
		PlayerAtt = Player:GetAttributes();
		wTitanBar.moneyChangedHandler = AddCallback(PlayerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		UpdateMoney();
	end
	
	import (AppCtrD.."DestinyPoints");
	if ShowDestinyPoints then
		--import (AppCtrD.."DestinyPoints");
		PlayerAtt = Player:GetAttributes();
		wTitanBar.dpChangedHandler = AddCallback(PlayerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		UpdateDestinyPoints();
	end
	
	-- Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue)
	ItemRemovedTimer = Turbine.UI.Control();
	
	ItemRemovedTimer.Update = function( sender, args )
		ItemRemovedTimer:SetWantsUpdates( false );
		UpdateBackpackInfos();
	end
	--

	import (AppCtrD.."BagInfos");
	if ShowBagInfos then
		--import (AppCtrD.."BagInfos");
		Backpack = Player:GetBackpack();
		wTitanBar.iaHandler = AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		wTitanBar.irHandler = AddCallback(Backpack, "ItemRemoved", function(sender, args) ItemRemovedTimer:SetWantsUpdates( true ); end);
		UpdateBackpackInfos();
	end
	
	import (AppCtrD.."PlayerInfos");
	if ShowPlayerInfos then
		--import (AppCtrD.."PlayerInfos");
		wTitanBar.levelChangedHandler = AddCallback(Player, "LevelChanged", function(sender, args) C["PLvl"]:SetText( Player:GetLevel() ); end);
		wTitanBar.nameChangedHandler = AddCallback(Player, "NameChanged", function(sender, args) C["PName"]:SetText( Player:GetName() ); end);
		UpdatePlayersInfos();
	end
	
	import (AppCtrD.."DurabilityInfos");
	itemEquipHandler = {};
	if ShowDurabilityInfos then
		--import (AppCtrD.."DurabilityInfos");
		--itemEquipHandler = {};
		UpdateDurabilityInfos();
	end

	-- Workaround for the ItemUnEquipped that fire before the Equipment was updated (Turnine API issue)
	ItemUnEquippedTimer = Turbine.UI.Control();
	
	ItemUnEquippedTimer.Update = function( sender, args )
		ItemUnEquippedTimer:SetWantsUpdates( false );
		UpdateEquipsInfos();
		UpdateDurabilityInfos();
	end
	--

	import (AppCtrD.."EquipInfos");
	if ShowEquipInfos then
		--import (AppCtrD.."EquipInfos");
		PlayerEquipment = Player:GetEquipment();
		wTitanBar.ieHandler = AddCallback(PlayerEquipment, "ItemEquipped", function(sender, args) UpdateEquipsInfos(); end);
		wTitanBar.iueHandler = AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) ItemUnEquippedTimer:SetWantsUpdates( true ); end);
		UpdateEquipsInfos();
	end
			
	
	
	import (AppCtrD.."PlayerLoc");
	if ShowPlayerLoc then
		--import (AppCtrD.."PlayerLoc");
		wTitanBar.ChatReceivedHandler = AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			sMess = args.Message;

			----                1111111111222222222233333333 
			----       1234567890123456789012345678901234567
			--sMess = "Entered the Bree-town - Trade channel";
			if GLocale == "en" then sE, sC, iE = "Entered", "-%s", 13;
			elseif GLocale == "fr" then sE, sC, iE = "Canal", "-%s", 7;
			elseif GLocale == "de" then sE, sC, iE = "Kanal", "-%s", 13; end

			local bFound = string.find(sMess, sE, 1);
			if bFound ~= nil then
				local iLoc = string.find(sMess, sC, 1);
				if iLoc ~= nil then
					-- Extract Location from args.Message
					local PLoc = string.sub( sMess, iE, iLoc - 1 );
					UpdatePlayerLoc(PLoc);
					ReplaceModuleLocation( "right" );
				end
			end
		end);

		PLoc = L["PLMsg"];
		UpdatePlayerLoc(PLoc);
	end
	
	import (AppCtrD.."GameTime");
	if ShowGameTime then
		--import (AppCtrD.."GameTime");
		--PlayerTime = Turbine.Engine.GetDate();
		--wTitanBar.gtsChangedHandler = AddCallback(PlayerTime, "SecondChanged", function(sender, args) UpdateGameTime(); end);
		UpdateGameTime();
	end
	
	OneTimer = Turbine.UI.Control();
	if ShowBagInfos or ShowEquipInfos or ShowDurabilityInfos then OneTimer:SetWantsUpdates( true ); NumSec = 0; end
		
	--Run these function at-starup only once, cause if TitanBar is loaded with in-game plugin manager some control does not update properly
	OneTimer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentsecond = currentdate.Second;
		
		if NumSec < 20 then -- Run for 20 secs.
			if (oldsecond ~= currentsecond) then
				if ShowBagInfos then UpdateBackpackInfos(); end
				if ShowEquipInfos then UpdateEquipsInfos();	end
				if ShowDurabilityInfos then UpdateDurabilityInfos(); end

				oldsecond = currentsecond;
				NumSec = NumSec + 1;
				--write("OneTimer: " .. NumSec .. " secs");
			end
		else
			OneTimer:SetWantsUpdates( false );
			ReplaceModuleLocation( "left" );
		end
	end
	--
	-- run these functions every second
	Timer = Turbine.UI.Control();
	Timer:SetWantsUpdates( true );
	
	Timer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentsecond = currentdate.Second;
		
		if (oldtime ~= currentsecond) then
			
			if ShowGameTime then UpdateGameTime(); end -- Until i found the second Changed event

			oldtime = currentsecond;
		end
	end
	--
	ReplaceModuleLocation( "all" );
end
-- **^