-- functions.lua
-- Written By Habna


function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

--**v Create a ToolTip Window v**
function createToolTipWin( xOffset, yOffset, xSize, ySize, side, header, text1, text2, text3 )
	ToolTipWin = Turbine.UI.Window();
	ToolTipWin:SetSize( xSize, ySize );
	--ToolTipWin:SetBackColor( red ); -- Debug purpose
	ToolTipWin:SetMouseVisible( false );
	ToolTipWin:SetZOrder( 15 );
	ToolTipWin.xOffset = xOffset;
	ToolTipWin.yOffset = yOffset;

	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( ToolTipWin );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 15, 12 );
	if side == "left" then topLeftCorner:SetBackground( resources.LeftBubble_TopLeftCorner.Background );
	elseif side == "right" then	topLeftCorner:SetBackground( resources.RightBubble_TopLeftCorner.Background ); end
	--**^
	--**v Mid Left v**
	midLeft = Turbine.UI.Control();
	midLeft:SetParent( ToolTipWin );
	midLeft:SetPosition( 0, 12 );
	midLeft:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midLeft:SetBackground( resources.Bubble_MidLeft.Background );
	--**^
	--**v Bottom Left Corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( ToolTipWin );
	botLeftCorner:SetPosition( 0, ToolTipWin:GetHeight() - 12 );
	botLeftCorner:SetSize( 15, 12 );
	botLeftCorner:SetBackground( resources.Bubble_BotLeftCorner.Background );
	--**^
	--**v Top v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( ToolTipWin );
	TopBar:SetPosition( 15, 0 );
	TopBar:SetSize( ToolTipWin:GetWidth() - 15, 12 );
	TopBar:SetBackground( resources.Bubble_Top.Background );
	--**^
	--**v Middle v**
	MidMid = Turbine.UI.Control();
	MidMid:SetParent( ToolTipWin );
	MidMid:SetPosition( 15, 12 );
	MidMid:SetSize( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	MidMid:SetBackground( resources.Bubble_Mid.Background );
	--**^
	--**v Bottom v**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( ToolTipWin );
	BotBar:SetPosition( 15, ToolTipWin:GetHeight() - 12 );
	BotBar:SetSize( ToolTipWin:GetWidth() - 5, 12 );
	BotBar:SetBackground( resources.Bubble_Bot.Background );
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( ToolTipWin );
	topRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, 0 );
	topRightCorner:SetSize( 15, 12 );
	if side == "left" then topRightCorner:SetBackground( resources.LeftBubble_TopRightCorner.Background );
	elseif side == "right" then topRightCorner:SetBackground( resources.RightBubble_TopRightCorner.Background ); end
	--**^
	--**v Mid Right v**
	midRight = Turbine.UI.Control();
	midRight:SetParent( ToolTipWin );
	midRight:SetPosition( ToolTipWin:GetWidth() - 15, 12 );
	midRight:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midRight:SetBackground( resources.Bubble_MidRight.Background );
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( ToolTipWin );
	botRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	botRightCorner:SetSize( 15, 12 );
	botRightCorner:SetBackground( resources.Bubble_BotRightCorner.Background );
	--**^
	
	lblheader = Turbine.UI.Label();
	lblheader:SetParent( ToolTipWin );
	lblheader:SetPosition( 10, 10 );
	lblheader:SetSize( xSize, ySize );
	lblheader:SetForeColor( blue );
	lblheader:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	lblheader:SetText( header );
	
	lbltext1 = Turbine.UI.Label();
	lbltext1:SetParent( ToolTipWin );
	lbltext1:SetPosition( 10, 25 );
	lbltext1:SetSize( xSize, 15 );
	lbltext1:SetForeColor( black );
	lbltext1:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext1:SetText( text1 );

	lbltext2 = Turbine.UI.Label();
	lbltext2:SetParent( ToolTipWin );
	lbltext2:SetPosition( 10, 45 );
	lbltext2:SetSize( xSize, 15 );
	lbltext2:SetForeColor( black );
	lbltext2:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext2:SetText( text2 );

	lbltext3 = Turbine.UI.Label();
	lbltext3:SetParent( ToolTipWin );
	lbltext3:SetPosition( 10, 60 );
	lbltext3:SetSize( xSize, 15 );
	lbltext3:SetForeColor( white );
	lbltext3:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext3:SetText( text3 );
	
	return ToolTipWin;
end

-- Legend
-- ( offsetX, offsetY, width, height, bubble side, header text, text1, text2, text3 )
function ShowToolTipWin( ToShow )
	if ToShow == "MoneyG" then TTW = createToolTipWin( 0, -17, string.len(L["MGh"]) * 7.5, 32, "left", L["MGh"] ); end -- Money infos Gold
	if ToShow == "MoneyS" then TTW = createToolTipWin( 0, -17, string.len(L["MSh"]) * 7.5, 32, "left", L["MSh"] ); end -- Money infos Silver
	if ToShow == "MoneyC" then TTW = createToolTipWin( 0, -17, string.len(L["MCh"]) * 7.5, 32, "left", L["MCh"] ); end -- Money infos Copper
	if ToShow == "DP" then TTW = createToolTipWin( 0, -19, string.len(L["DPh"]) * 7.5, 32, "left", L["DPh"] ); end -- Destiny points
	if ToShow == "Bag" then TTW = createToolTipWin( 0, -17, string.len(L["BIh"]) * 7.5, 45, "left", L["BIh"], L["BIt1"] ); end --Bag infos
	if ToShow == "PIcon" then  -- Player class
		local txt = L["PIICON"] .. PlayerRaceIs .. PlayerClassIs
		TTW = createToolTipWin( 0, -17, string.len(txt) * 8.2, 32, "left", txt );
	end
	if ToShow == "PLvl" then TTW = createToolTipWin( 0, -17, string.len(L["PILVL"]) * 8, 32, "left", L["PILVL"] ); end -- Player level
	if ToShow == "PName" then TTW = createToolTipWin( 0, -17, string.len(L["PINAME"]) * 8.3, 32, "left", L["PINAME"] ); end -- Player name
	if ToShow == "EI" then TTW = createToolTipWin( 0, -17, string.len(L["EIh"]) * 7.5, 45, "left", L["EIh"], L["EIt1"] ); end -- Equipment infos
	if ToShow == "DI" then TTW = createToolTipWin( 0, -17, string.len(L["DIh"]) * 7.2, 45, "left", L["DIh"], L["EIt1"] ); end -- Durability infos

	if ToShow == "PL" then TTW = createToolTipWin( string.len(L["PLh"]) * 8 - 17, -17, string.len(L["PLh"]) * 8, 32, "right", L["PLh"] ); end -- Player Location
	if ToShow == "GT" then TTW = createToolTipWin( string.len(L["GTh"]) * 7.5 - 17, -17, string.len(L["GTh"]) * 7.5, 32, "right", L["GTh"] ); end -- Game Time

	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	ToolTipWin:SetPosition( mouseX - ToolTipWin.xOffset, mouseY - ToolTipWin.yOffset);
	ToolTipWin:SetVisible( true );
end
--**^
--**v Update money on TitanBar v**
function UpdateMoney()
	local money = PlayerAtt:GetMoney();
	local cp = math.fmod( money, 100 ); -- Copper
	money = ( money - cp) / 100;
	local sp = math.fmod( money, 1000 ); -- Silver
	local gp = ( money - sp ) / 1000; -- Gold
	
	C["MIGLbl"]:SetText( gp );
	C["MIGLbl"]:SetPosition( 5, 0 );
	C["MIGLbl"]:SetSize( string.len(C["MIGLbl"]:GetText()) * 7.5, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["MIGIcon"]:SetPosition( C["MIGLbl"]:GetLeft() + C["MIGLbl"]:GetWidth(), 4 );

	C["MISLbl"]:SetText( sp );
	C["MISLbl"]:SetPosition( C["MIGIcon"]:GetLeft() + C["MIGIcon"]:GetWidth() + 5, 0 );
	C["MISLbl"]:SetSize( string.len(C["MISLbl"]:GetText()) * 7.5, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["MISIcon"]:SetPosition( C["MISLbl"]:GetLeft() + C["MISLbl"]:GetWidth(), 4 );

	C["MICLbl"]:SetText( cp );
	C["MICLbl"]:SetPosition( C["MISIcon"]:GetLeft() + C["MISIcon"]:GetWidth() + 5, 0 );
	C["MICLbl"]:SetSize( string.len(C["MICLbl"]:GetText()) * 7.5, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["MICIcon"]:SetPosition( C["MICLbl"]:GetLeft() + C["MICLbl"]:GetWidth(), 4 );
	
	C["MICtr"]:SetSize( C["MIGLbl"]:GetWidth() + C["MIGIcon"]:GetWidth() + C["MISLbl"]:GetWidth() + C["MISIcon"]:GetWidth() + C["MICLbl"]:GetWidth() + C["MICIcon"]:GetWidth() + 15, wTitanBar:GetHeight() );
end
--**^
--**v Update destiny point currencies on TitanBar v**
function UpdateDestinyPoints()
	C["DPLbl"]:SetText( PlayerAtt:GetDestinyPoints() );
	C["DPLbl"]:SetSize( string.len(C["DPLbl"]:GetText()) * 7.5, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["DPIcon"]:SetPosition( C["DPLbl"]:GetLeft() + C["DPLbl"]:GetWidth() + 2, 4 );

	C["DPCtr"]:SetSize( C["DPLbl"]:GetWidth() + C["DPIcon"]:GetWidth() + 7, wTitanBar:GetHeight() );
end
--**^
--**v Update backpack infos on TitanBar v**
function UpdateBackpackInfos()
	local max = Backpack:GetSize();
	local freeslots = 0;

	for i = 1, max do
		if ( Backpack:GetItem( i ) == nil ) then freeslots = freeslots + 1; end
	end

	C["BInfo"]:SetText( max - freeslots .. "/" .. max );

	C["BICtr"]:SetSize( C["BIconCtr"]:GetWidth() + C["BInfo"]:GetWidth() + 7, wTitanBar:GetHeight() );
end
--**^
--**v Update player infos on TitanBar v**
function UpdatePlayersInfos()
	PlayerRaceIs = Player:GetRace();
	if PlayerRaceIs == 0 then PlayerRaceIs = ""; end -- Undefined
	if PlayerRaceIs == 65 then PlayerRaceIs = L["Elf"]; end
	if PlayerRaceIs == 23 then PlayerRaceIs = L["Man"]; end
	if PlayerRaceIs == 73 then PlayerRaceIs = L["Dwarf"]; end
	if PlayerRaceIs == 81 then PlayerRaceIs = L["Hobbit"]; end

	PlayerClassIs = Player:GetClass();
	if PlayerClassIs == 23 then PlayerClassIs = L["Guardian"]; PlayerIconCodeIs = "0x41007dd8"; end
	if PlayerClassIs == 24 then PlayerClassIs = L["Captain"]; PlayerIconCodeIs = "0x41007dd7"; end
	if PlayerClassIs == 31 then PlayerClassIs = L["Minstrel"]; PlayerIconCodeIs = "0x41007dd6"; end
	if PlayerClassIs == 40 then PlayerClassIs = L["Burglar"]; PlayerIconCodeIs = "0x41007ddb"; end
	if PlayerClassIs == 162 then PlayerClassIs = L["Hunter"]; PlayerIconCodeIs = "0x41007dda"; end
	if PlayerClassIs == 172 then PlayerClassIs = L["Champion"]; PlayerIconCodeIs = "0x41007ddc"; end
	if PlayerClassIs == 185 then PlayerClassIs = L["Lore-Master"]; PlayerIconCodeIs = "0x41007dd9"; end
	if PlayerClassIs == 191 then PlayerClassIs = L["Ranger"]; PlayerIconCodeIs = "default"; end --???  Default icon code, need real one thought
	if PlayerClassIs == 193 then PlayerClassIs = L["Rune-Keeper"]; PlayerIconCodeIs = "runekeeper"; end --Using my icon, need in-game one thought
	if PlayerClassIs == 194 then PlayerClassIs = L["Warden"]; PlayerIconCodeIs = "warden"; end --Using my icon, need in-game one thought

	-- 0x41008500 (red eye) 32x32

	-- 0x41007ddd (Reaver class icon) 25x25 - Class no71
	-- 0x41007de0 (Weaver class icon) 25x25 - Class no127
	-- 0x41007ddf (Blackarrow class icon) 25x25 - Class no179
	-- 0x41007dde (Warleader class icon) 25x25 - Class no52
	-- 0x41007de1 (Stalker class icon) 25x25 - Class no126
	--			  (Defiler class icon) 25x25 - Class no128
	
	if PlayerIconCodeIs == "default" then C["PIConCtr"]:SetBackground( resources.Ring.Background );
	elseif PlayerIconCodeIs == "runekeeper" then C["PIConCtr"]:SetBackground( resources.RuneKeeper.Background );
	elseif PlayerIconCodeIs == "warden" then C["PIConCtr"]:SetBackground( resources.Warden.Background );
	else C["PIConCtr"]:SetBackground( tonumber(PlayerIconCodeIs) ); end 
	
	C["PName"]:SetText( Player:GetName() );
	C["PName"]:SetSize( string.len(C["PName"]:GetText()) * 7.5, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["PLvl"]:SetText( Player:GetLevel() );
	C["PLvl"]:SetSize( string.len(C["PLvl"]:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["PName"]:SetPosition( C["PLvl"]:GetLeft() + C["PLvl"]:GetWidth() + 2, 0 );

	C["PICtr"]:SetSize( C["PIConCtr"]:GetWidth() + C["PLvl"]:GetWidth() + C["PName"]:GetWidth() + 9, wTitanBar:GetHeight() );
end
--**^
--**v Update equipment infos on TitanBar v**
function UpdateEquipsInfos()
	LoadEquipmentTable();

	local PlayerEquipment = Player:GetEquipment();
	
	local itemEquip = {};
	local itemTotScore, itemScore = 0, 0;
	
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Durability = PlayerEquipItem:GetDurability();
		else
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
		end

		-- Item Score from it's Quality & Durability
		if itemEquip[i].Quality == 5 then itemScore = 50; end -- Common
		if itemEquip[i].Quality == 4 then itemScore = 100; end -- Uncommon
		if itemEquip[i].Quality == 3 then itemScore = 150; end -- Incomparable
		if itemEquip[i].Quality == 2 then itemScore = 200; end -- Rare
		if itemEquip[i].Quality == 1 then itemScore = 250; end -- Legendary
		if itemEquip[i].Quality == 0 then itemScore = 0; end -- undefined
		
		if itemEquip[i].Durability == 0 then itemScore = itemScore + 0; end -- undefined
		if itemEquip[i].Durability == 7 then itemScore = itemScore + 5; end -- Weak / Faible
		if itemEquip[i].Durability == 1 then itemScore = itemScore + 10; end -- Substantial
		if itemEquip[i].Durability == 2 then itemScore = itemScore + 20; end -- Brittle / Fragile
		if itemEquip[i].Durability == 3 then itemScore = itemScore + 30; end -- Normal
		if itemEquip[i].Durability == 4 then itemScore = itemScore + 40; end -- Tought / Robuste
		if itemEquip[i].Durability == 5 then itemScore = itemScore + 50; end -- Flimsy / Fragile ??
		if itemEquip[i].Durability == 6 then itemScore = itemScore + 60; end -- Indestructible
		
		itemTotScore = itemTotScore + itemScore;
	end

	C["EILbl"]:SetText( itemTotScore );
	C["EILbl"]:SetSize( string.len(C["EILbl"]:GetText()) * 7.5, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["EILbl"]:SetPosition( C["EIConCtr"]:GetLeft() + C["EIConCtr"]:GetWidth() + 2, 0 );

	C["EICtr"]:SetSize( C["EIConCtr"]:GetWidth() + C["EILbl"]:GetWidth() + 7, wTitanBar:GetHeight() );

	UpdateDurabilityInfos();
end
--**^
--**v Update Player Durability infos on TitanBar v**
function UpdateDurabilityInfos()
	--write( "TitanBar: Updating Durability infos");
	LoadEquipmentTable();

	local PlayerEquipment = Player:GetEquipment();
	local itemEquip = {};
	local itemsTotDurability, itemDurability, numItems = 0, 0, 0;
	
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = PlayerEquipItem:GetName();
			WearState = PlayerEquipItem:GetWearState();
			itemEquip[i].WearState = WearState
			if WearState ~= 0 then numItems = numItems + 1; end -- Undefined item must not be count (Pocket item are as Undefined Wear State, they are indestructible)
			if itemEquipHandler[i] == nil then itemEquipHandler[i] = AddCallback(PlayerEquipItem, "WearStateChanged", function(sender, args) UpdateDurabilityInfos(); end); end
		else
			itemEquip[i].Name = "item not present";
			itemEquip[i].WearState = 0;
			itemEquip[i].Handler = false;
		end
		
		-- Item Wear State
		if itemEquip[i].WearState == 0 then itemDurability = 0; end -- undefined
		if itemEquip[i].WearState == 2 then itemDurability = 100; end -- Pristine / parfait
		if itemEquip[i].WearState == 4 then itemDurability = 75; end -- Worn / us
		if itemEquip[i].WearState == 1 then itemDurability = 50; end -- Damaged / endommag
		if itemEquip[i].WearState == 3 then itemDurability = 0; end -- Broken / cass
		
		itemsTotDurability = itemsTotDurability + itemDurability;
	end

	itemsTotDurability = itemsTotDurability / numItems;
	if itemsTotDurability == 100 then itemsTotDurability = string.format( "%.0f", itemsTotDurability );
	else itemsTotDurability = string.format( "%.2f", itemsTotDurability ); end
	
	C["DILbl"]:SetText( itemsTotDurability .. "%" );
	C["DILbl"]:SetSize( string.len(C["DILbl"]:GetText()) * 7.5, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["DILbl"]:SetPosition( C["DIConCtr"]:GetLeft() + C["DIConCtr"]:GetWidth() + 2, 0 );

	C["DICtr"]:SetSize( C["DIConCtr"]:GetWidth() + C["DILbl"]:GetWidth() + 7, wTitanBar:GetHeight() );
end
--**^

--**v Update Player Location on TitanBar v**
function UpdatePlayerLoc( value )
	--write( "TitanBar: Updating Player Location");

	C["PLLbl"]:SetText( value );
	C["PLLbl"]:SetSize( string.len(C["PLLbl"]:GetText()) * 7.2, wTitanBar:GetHeight() ); --Auto size with text lenght
	C["PLLbl"]:SetPosition( 5, 0 );

	C["PLCtr"]:SetSize( C["PLLbl"]:GetWidth() + 5, wTitanBar:GetHeight() );
end
--**^
--**v Update game time on TitanBar v**
function UpdateGameTime()
	--write( "TitanBar: Updating Game Time");
	local currentdate = Turbine.Engine.GetDate();
	local currenthour = currentdate.Hour;
	local currentminute = currentdate.Minute;
	
	if currentminute < 10 then currentminute = "0" .. currentminute; end
	
	C["GTLbl"]:SetText( currenthour .. ":" .. currentminute );
	C["GTLbl"]:SetSize( string.len(C["GTLbl"]:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	
	C["GTCtr"]:SetSize( C["GTLbl"]:GetWidth() + 5, wTitanBar:GetHeight() );
end
--**^

-- **v Change TitanBar back color v**
function ChangeColor()
	if SetToAll then
		wTitanBar:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) );
		if ShowMoney then C["MICtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDestinyPoints then C["DPCtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowBagInfos then C["BICtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowPlayerInfos then C["PICtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowEquipInfos then C["EICtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDurabilityInfos then C["DICtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end

		if ShowPlayerLoc then C["PLCtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowGameTime then C["GTCtr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
	else
		wTitanBar:SetBackColor( Turbine.UI.Color(bcAlpha, bcRed, bcGreen, bcBlue) );
		if ShowMoney then C["MICtr"]:SetBackColor( Turbine.UI.Color(MbcAlpha, MbcRed, MbcGreen, MbcBlue) ); end
		if ShowDestinyPoints then C["DPCtr"]:SetBackColor( Turbine.UI.Color(DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue) ); end
		if ShowBagInfos then C["BICtr"]:SetBackColor( Turbine.UI.Color(BbcAlpha, BbcRed, BbcGreen, BbcBlue) ); end
		if ShowPlayerInfos then C["PICtr"]:SetBackColor( Turbine.UI.Color(PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue) ); end
		if ShowEquipInfos then C["EICtr"]:SetBackColor( Turbine.UI.Color(EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue) ); end
		if ShowDurabilityInfos then C["DICtr"]:SetBackColor( Turbine.UI.Color(DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue) ); end

		if ShowPlayerLoc then C["PLCtr"]:SetBackColor( Turbine.UI.Color(PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue) ); end
		if ShowGameTime then C["GTCtr"]:SetBackColor( Turbine.UI.Color(GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue) ); end

		if sFrom == "TitanBar" then wTitanBar:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "Money" then C["MICtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DP" then C["DPCtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "BI" then C["BICtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "PI" then C["PICtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "EI" then C["EICtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DI" then C["DICtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end

		if sFrom == "PL" then C["PLCtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "GT" then C["GTCtr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
	end
end
--**^
-- **v Replace control on TitanBar v**
function ReplaceModuleLocation( value )
	if value == "left" then
		--Module starting at left on TitanBar
		local ModuleLeftPos = 0;
		if ShowMoney then C["MICtr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + C["MICtr"]:GetWidth(); end
		if ShowDestinyPoints then C["DPCtr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + C["DPCtr"]:GetWidth(); end
		if ShowBagInfos then C["BICtr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + C["BICtr"]:GetWidth(); end
		if ShowPlayerInfos then C["PICtr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + C["PICtr"]:GetWidth(); end
		if ShowEquipInfos then C["EICtr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + C["EICtr"]:GetWidth(); end
		if ShowDurabilityInfos then C["DICtr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + C["DICtr"]:GetWidth(); end
	elseif value == "right" then
		--Module starting at right on TitanBar
		local ModuleRightPos = wTitanBar:GetWidth();
		if ShowGameTime then C["GTCtr"]:SetPosition( ModuleRightPos - C["GTCtr"]:GetWidth(), 0 ); ModuleRightPos = C["GTCtr"]:GetLeft(); end
		if ShowPlayerLoc then C["PLCtr"]:SetPosition( ModuleRightPos - C["PLCtr"]:GetWidth(), 0 ); ModuleRightPos = C["PLCtr"]:GetLeft(); end
	elseif value == "all" then
		ReplaceModuleLocation( "left" );
		ReplaceModuleLocation( "right" );
	end
end
--**^
-- **v Set background color v**
function SetBackgroundColor()
	if frmBG then wBackground:Close(); end
	import (AppDirD.."background"); -- LUA background file
	frmBackground();
	_G.sFromCtr = "TitanBar";
end
--**^
-- **v Reset background color v**
function ResetBackgroundColor()
	bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3;
	wTitanBar:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	SaveSettings();
	_G.sFromCtr = "TitanBar";
end
--**^
-- **v Change TitanBar language v**
function ChangeTitanBarLanguage()
	SaveSettings();
	ReloadTitanBar();
end
--**^
-- **v Show Shell Command window v**
function HelpInfo()
	if frmSC then
		wShellCmd:Close();
	else
		import(AppDirD.."shellcmd"); -- LUA shell command file
		frmShellCmd();
	end
end
-- **^
function ReloadControl( value )
	if value == "this" then
		if _G.sFromCtr == "Money" then UpdateMoney(); end
		if _G.sFromCtr == "DP" then UpdateDestinyPoints(); end
		if _G.sFromCtr == "BI" then UpdateBackpackInfos(); end
		if _G.sFromCtr == "PI" then UpdatePlayersInfos(); end
		if _G.sFromCtr == "EI" then UpdateEquipsInfos(); end
		if _G.sFromCtr == "DI" then UpdateDurabilityInfos(); end

		if _G.sFromCtr == "PL" then UpdatePlayerLoc(PLoc); end
		if _G.sFromCtr == "GT" then UpdateGameTime(); end
	elseif value == "ctr" then
		if ShowMoney then UpdateMoney(); end
		if ShowDestinyPoints then UpdateDestinyPoints(); end
		if ShowBagInfos then UpdateBackpackInfos(); end
		if ShowPlayerInfos then UpdatePlayersInfos(); end
		if ShowEquipInfos then UpdateEquipsInfos(); end
		if ShowDurabilityInfos then UpdateDurabilityInfos(); end

		if ShowPlayerLoc then UpdatePlayerLoc(); end
		if ShowGameTime then UpdateGameTime(); end
	end
end

function LoadEquipmentTable()
	EquipSlots = {
		["Earring1"] = Turbine.Gameplay.Equipment.Earring1; --no 13
		["Earring2"] = Turbine.Gameplay.Equipment.Earring2; --no 14
		["Necklace"] = Turbine.Gameplay.Equipment.Necklace; --no 10
		["Pocket"] = Turbine.Gameplay.Equipment.Pocket; --no 15
		["Bracelet1"] = Turbine.Gameplay.Equipment.Bracelet1; --no 8
		["Bracelet2"] = Turbine.Gameplay.Equipment.Bracelet2; --no 9
		["Ring1"] = Turbine.Gameplay.Equipment.Ring1; --no 11
		["Ring2"] = Turbine.Gameplay.Equipment.Ring2; --no 12
		["Head"] = Turbine.Gameplay.Equipment.Head; --no 1
		["Shoulder"] = Turbine.Gameplay.Equipment.Shoulder; --no 6
		["Back"] = Turbine.Gameplay.Equipment.Back; --no 7
		["Chest"] = Turbine.Gameplay.Equipment.Chest; --no 2
		["Gloves"] = Turbine.Gameplay.Equipment.Gloves; --no 4
		["Legs"] = Turbine.Gameplay.Equipment.Legs; --no 3
		["Boots"] = Turbine.Gameplay.Equipment.Boots; --no 5
		["PrimaryWeapon"] = Turbine.Gameplay.Equipment.PrimaryWeapon; --no 16
		["SecondaryWeapon"] = Turbine.Gameplay.Equipment.SecondaryWeapon; --no 17
		["RangedWeapon"] = Turbine.Gameplay.Equipment.RangedWeapon; --no 18
		["Class"] = Turbine.Gameplay.Equipment.Class; --no 20
		["CraftTool"] = Turbine.Gameplay.Equipment.CraftTool; --no 19
	};

	Slots = {"Head", "Earring1", "Earring2", "Necklace", "Shoulder", "Back", "Chest", "Bracelet1", "Bracelet2",
		"Ring1", "Ring2", "Gloves", "Legs", "Boots", "Pocket", "PrimaryWeapon", "SecondaryWeapon", "RangedWeapon",
		"CraftTool", "Class"};
end


-- For debug purpose
function ShowTableContent(table)
	for k,v in pairs(table) do
		write("key:"..tostring(k)..", value:"..tostring(v));
	end
end